package test;
import static org.junit.Assert.*;
import static test.TDUListIterator3Test.*;
import org.junit.Test;
import java.util.ListIterator;
import kadai.TDUList5;
import kotae.Node;
import kotae.TDUListIterator4;
import kotae.TDUListIterator5;
public class TDUListIterator5Test {
	@Test
	public void testConstructor() {
		TDUListIterator5 listIterator = new TDUListIterator5((new Node<String>()),0);
		assertTrue(listIterator instanceof TDUListIterator4);
	}
	@Test
	public void testLast() {
		Node<String> node = getEmptyList();
		TDUListIterator5 listIterator = new TDUListIterator5(node,0);
		assertNull(listIterator.last);
		listIterator.add("abc");
		assertNull(listIterator.last);
		listIterator = new TDUListIterator5(node,0);
		assertEquals("abc",listIterator.next());
		assertEquals("abc",listIterator.last.get());
		listIterator.add("def");
		assertNull(listIterator.last);	
	}
	@Test(expected=IllegalStateException.class)
	public void testSet0() {
		TDUListIterator5 listIterator = new TDUListIterator5(getEmptyList(),0);
		listIterator.set("xyz");
	}
	@Test(expected=IllegalStateException.class)
	public void testSet1() {
		TDUList5 list = new TDUList5();
		list.add("abc");
		ListIterator<String> listIterator =  list.listIterator(0);
		assertEquals("abc",listIterator.next());
		listIterator.add("def");
		listIterator.set("xyz");
	}
	@Test
	public void testSet2() {
		Node<String> list = getList();
		TDUListIterator5 listIterator = new TDUListIterator5(list,0);
		assertEquals("abc",listIterator.next());
		listIterator.set("123");
		assertEquals(null,listIterator.next());
		listIterator.set("456");
		assertEquals("ghi",listIterator.next());
		listIterator.set("789");
		assertEquals("123",list.get());
		assertEquals("456",list.next.get());
		assertEquals("789",list.next.next.get());
	}
	@Test
	public void testSet3() {
		Node<String> list = getList();
		TDUListIterator5 listIterator = new TDUListIterator5(list,1);
		assertEquals(null,listIterator.next());
		listIterator.set("123");
		listIterator.add("jkl");
		assertEquals("ghi",listIterator.next());
		listIterator.set("456");
		assertEquals("abc",list.get());
		assertEquals("123",list.next.get());
		assertEquals("jkl",list.next.next.get());
		assertEquals("456",list.next.next.next.get());
	}
}