package test;
import static org.junit.Assert.*;

import java.util.ListIterator;

import kadai.TDUList5;
import kotae.Node;
import kotae.TDUListIterator;
import kotae.TDUListIterator5;

import org.junit.Test;
import static test.TDUListIterator3Test.*;
public class TDUListIteratorTest {	
	@Test(expected=IndexOutOfBoundsException.class)
	public void testConstructor00(){
		assertNotNull(new TDUListIterator<String>(getEmptyList(),0));
		new TDUListIterator<String>(getEmptyList(),-1);
	}
	@Test(expected=IndexOutOfBoundsException.class)
	public void testConstructor01(){
		new TDUListIterator<String>(getEmptyList(),1);
	}
	@Test(expected=IndexOutOfBoundsException.class)
	public void testConstructor30(){
		new TDUListIterator<String>(getList(),-1);
	}
	@Test(expected=IllegalStateException.class)
	public void testSet0() {
		TDUListIterator<String> listIterator = new TDUListIterator<String>(getEmptyList(),0);
		listIterator.set("xyz");
	}
	@Test(expected=IllegalStateException.class)
	public void testSet1() {
		TDUListIterator<String> listIterator = new TDUListIterator<String>(getEmptyList(),0);
		listIterator.add("abc");
		listIterator.set("xyz");
	}
	@Test(expected=UnsupportedOperationException.class)
	public void removeTest(){
		TDUListIterator<String> listIterator = new TDUListIterator<String>(getList(),0);
		listIterator.next();
		listIterator.remove();
	}
	@Test(expected=IllegalStateException.class)
	public void testSet50() {
		TDUListIterator5 listIterator = new TDUListIterator5(getEmptyList(),0);
		listIterator.set("xyz");
	}
	@Test(expected=IllegalStateException.class)
	public void testSet51() {
		TDUList5 list = new TDUList5();
		list.add("abc");
		ListIterator<String> listIterator =  list.listIterator(0);
		assertEquals("abc",listIterator.next());
		listIterator.add("def");
		listIterator.set("xyz");
	}
	@Test
	public void testSet52() {
		Node<String> list = getList();
		TDUListIterator5 listIterator = new TDUListIterator5(list,0);
		assertEquals("abc",listIterator.next());
		listIterator.set("123");
		assertEquals(null,listIterator.next());
		listIterator.set("456");
		assertEquals("ghi",listIterator.next());
		listIterator.set("789");
		assertEquals("123",list.get());
		assertEquals("456",list.next.get());
		assertEquals("789",list.next.next.get());
	}
	@Test
	public void testSet53() {
		Node<String> list = getList();
		TDUListIterator5 listIterator = new TDUListIterator5(list,1);
		assertEquals(null,listIterator.next());
		listIterator.set("123");
		listIterator.add("jkl");
		assertEquals("ghi",listIterator.next());
		listIterator.set("456");
		assertEquals("abc",list.get());
		assertEquals("123",list.next.get());
		assertEquals("jkl",list.next.next.get());
		assertEquals("456",list.next.next.next.get());
	}
}