package test;
import static org.junit.Assert.*;
import java.util.Iterator;
import kotae.TDUList;
import org.junit.Test;
public class TDUListTest {
	@Test
	public void testString(){
		TDUList<String> list = new TDUList<String>();
		list.add("abc");
		list.add(null);
		list.add("ghi");
		assertEquals(3,list.size());
		Iterator<String> iterator = list.iterator();
		assertTrue(iterator.hasNext());
		assertEquals("abc",iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals(null,iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals("ghi",iterator.next());
		assertFalse(iterator.hasNext());	
		list.set(1,"def");
		assertEquals("[abc, def, ghi]",list.toString());
	}
	@Test
	public void testDoouble(){
		TDUList<Double> list = new TDUList<Double>();
		list.add(1.23);
		list.add(null);
		list.add(7.89);
		assertEquals(3,list.size());
		Iterator<Double> iterator = list.iterator();
		assertTrue(iterator.hasNext());
		assertEquals(new Double(1.23),iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals(null,iterator.next());
		assertTrue(iterator.hasNext());
		assertEquals(new Double(7.89),iterator.next());
		assertFalse(iterator.hasNext());
		list.set(1, 4.56);
		assertEquals("[1.23, 4.56, 7.89]",list.toString());
	}
}